'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

require('isomorphic-fetch');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactApollo = require('react-apollo');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Use a single instance on a client
var apolloClient = null;

function getApolloClient(apolloClientSettings, initialState, ssrMode, context) {

  var settings = null;

  if (apolloClientSettings instanceof Function) {
    settings = apolloClientSettings(initialState, ssrMode, context);
  } else {
    settings = (0, _extends3.default)({}, apolloClientSettings, { initialState: initialState, ssrMode: ssrMode });
  }

  // If apolloClientSettings returns a function then assume you are going to return an ApolloClient  
  if (settings instanceof Function) {
    return settings(initialState, ssrMode, context);
  } else {

    if (!process.browser) {
      // THE SERVER SHOULD NOT SHARE AN INSTANCE ACROSS REQUESTS!
      return new _reactApollo.ApolloClient(settings);
    } else if (apolloClient) {
      // Client can reuse an instance if its available
      return apolloClient;
    } else {
      // Create client instance
      apolloClient = new _reactApollo.ApolloClient(settings);
      return apolloClient;
    }
  }
}

exports.default = function () {
  var apolloClientSettings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    connectToDevTools: process.browser && false,
    dataIdFromObject: function dataIdFromObject(result) {
      return result.id || null;
    },
    networkInterface: (0, _reactApollo.createNetworkInterface)({
      uri: process.env.GRAPHQL_URL,
      opts: {
        credentials: 'same-origin'
      }
    })
  };
  var getReduxStore = arguments[1];

  return function (Component) {
    return function (_React$Component) {
      (0, _inherits3.default)(_class, _React$Component);

      (0, _createClass3.default)(_class, null, [{
        key: 'getInitialProps',
        value: function () {
          var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(context) {
            var client, store, props, app, storeState;
            return _regenerator2.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:

                    // Get client or build client and custom store if provided.
                    client = getApolloClient(apolloClientSettings, undefined, !process.browser, context);
                    store = getReduxStore && getReduxStore(client, client.initialState);
                    _context.t0 = _extends3.default;
                    _context.t1 = {
                      url: { query: context.query, pathname: context.pathname } };
                    _context.next = 6;
                    return Component.getInitialProps ? Component.getInitialProps(context) : {};

                  case 6:
                    _context.t2 = _context.sent;
                    props = (0, _context.t0)(_context.t1, _context.t2);

                    if (process.browser) {
                      _context.next = 12;
                      break;
                    }

                    app = _react2.default.createElement(_reactApollo.ApolloProvider, { client: client, store: store }, _react2.default.createElement(Component, props));
                    _context.next = 12;
                    return (0, _reactApollo.getDataFromTree)(app);

                  case 12:
                    storeState = store && store.getState();
                    return _context.abrupt('return', (0, _extends3.default)({
                      initialState: (0, _extends3.default)({}, storeState, {
                        apollo: {
                          data: client.getInitialState().data
                        }
                      })
                    }, props));

                  case 14:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          function getInitialProps(_x2) {
            return _ref.apply(this, arguments);
          }

          return getInitialProps;
        }()
      }]);

      function _class(props) {
        (0, _classCallCheck3.default)(this, _class);

        // We dont send context on the second server render as it should use initialState and not make a network request.
        var _this = (0, _possibleConstructorReturn3.default)(this, (_class.__proto__ || (0, _getPrototypeOf2.default)(_class)).call(this, props));

        _this.client = getApolloClient(apolloClientSettings, _this.props.initialState, !process.browser);
        _this.store = getReduxStore && getReduxStore(_this.client, _this.props.initialState);
        return _this;
      }

      (0, _createClass3.default)(_class, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(_reactApollo.ApolloProvider, { client: this.client, store: this.store }, _react2.default.createElement(Component, this.props));
        }
      }]);

      return _class;
    }(_react2.default.Component);
  };
};